package jp.mosp.common.part;

import java.text.NumberFormat;
import java.util.Calendar;
import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseDto;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;

/**
 * e탁\bhɊւPartNX
 * @author yoshida
 *	@version	0.0.1
 */
public class VariousPart {

	/**
	 * 폜tOXg擾
	 * @return 폜tOXg
	 */
	public static String[][] getDeleteArray() {
		String[][] array = new String[2][2];
		array[0][0] = String.valueOf(MospConst.DELETE_FLAG_OFF);
		array[0][1] = MospConst.DELETE_FLAG_OFF_NAME;
		array[1][0] = String.valueOf(MospConst.DELETE_FLAG_ON);
		array[1][1] = MospConst.DELETE_FLAG_ON_NAME;
		return array;
	}

	/**
	 * KptOXg擾
	 * @return 폜tOXg
	 */
	public static String[][] getApplicableFlagArray() {
		String[][] array = new String[2][2];
		array[0][0] = String.valueOf(CommonConst.APPLICABLE_FLAG_OFF);
		array[0][1] = CommonConst.NAM_APPLICABLE_FLAG_OFF;
		array[1][0] = String.valueOf(CommonConst.APPLICABLE_FLAG_ON);
		array[1][1] = CommonConst.NAM_APPLICABLE_FLAG_ON;
		return array;
	}

	/**
	 * f[^݊mF
	 * @param dto mFΏDTO
	 * @return boolean	ΏDTOݗL
	 * @throws MospException
	 */
	public static boolean chkExistDto(BaseDto dto) {
		if (dto == null) {
			return false;
		}
		return true;
	}

	/**
	 * f[^݊mF
	 * @param obj mFΏObject
	 * @return boolean	ΏObjectݗL
	 * @throws MospException
	 */
	public static boolean chkExistObject(Object obj) {
		if (obj == null) {
			return false;
		}
		return true;
	}

	/**
	 * {R[hz擾
	 * @return	{R[hz
	 * <p>
	 * [0]c
	 * [1]cI𕔏
	 * [2]cS
	 * </p>
	 */
	public static int[] getManageCode() {
		int[] aryCode = new int[3];
		aryCode[0] = Integer.parseInt(CommonConst.NUM_BELONGING_SECTION);
		aryCode[1] = Integer.parseInt(CommonConst.NUM_SELECT_SECTION);
		aryCode[2] = Integer.parseInt(CommonConst.NUM_ALL_SECTION);
		return aryCode;
	}

	/**
	 * L[l擾(L[)
	 * @param key2		ΏۃL[
	 * @param keyIndex L[CfbNX
	 * @return L[l
	 */
	public static String getKeyValue(String key, int keyIndex) {
		String[] aryKey= key.split(CommonConst.KEY_SEPARATOR);
		return aryKey[keyIndex];
	}


	/**
	 * jݒ
	 * @param dayOfWeek j
	 * @return j
	 */
	public static String getDayOfWeek(int dayOfWeek) {
		switch (dayOfWeek) {
		case Calendar.SUNDAY:
			return CommonConst.NAM_SUNDAY;
		case Calendar.MONDAY:
			return CommonConst.NAM_MONDAY;
		case Calendar.TUESDAY:
			return CommonConst.NAM_TUESDAY;
		case Calendar.WEDNESDAY:
			return CommonConst.NAM_WEDNESDAY;
		case Calendar.THURSDAY:
			return CommonConst.NAM_THURSDAY;
		case Calendar.FRIDAY:
			return CommonConst.NAM_FRIDAY;
		case Calendar.SATURDAY:
			return CommonConst.NAM_SATURDAY;
		default:
			return "";
		}
	}

	/**
	 * o͔͈̓v_EXg
	 * @return	String[][]	o͔͈͔z
	 */
	public static String[][] getOutputScopeArray() {
		// ͈̓v_EXg쐬
		String[][] aryScope = new String[3][2];
		aryScope[0][0] = CommonConst.CODE_SCOPE_PERSONAL;
		aryScope[0][1] = CommonConst.NAM_SCOPE_PERSONAL;
		aryScope[1][0] = CommonConst.CODE_SCOPE_SECTION;
		aryScope[1][1] = CommonConst.NAM_SCOPE_SECTION;
		aryScope[2][0] = CommonConst.CODE_SCOPE_ALL;
		aryScope[2][1] = CommonConst.NAM_SCOPE_ALL;
		return aryScope;
	}

	/**
	 * FXe[^XR[hXg擾
	 * @return FXe[^XR[hXgz
	 * <p>
	 * [0]cFi\j
	 * [1]cꎟF
	 * [2]cꎟ
	 * [3]c񎟏F
	 * [4]c񎟍
	 * </p>
	 */
	public static String[] getApprovalStatusCodeArray() {
		// z̍쐬
		String[] aryStatus = new String[5];
		aryStatus[0] = CommonConst.NUM_ATTENDANCE_REQUEST;
		aryStatus[1] = CommonConst.NUM_ATTENDANCE_1ST_APPROVED;
		aryStatus[2] = CommonConst.NUM_ATTENDANCE_1ST_RETURNED;
		aryStatus[3] = CommonConst.NUM_ATTENDANCE_2ND_APPROVED;
		aryStatus[4] = CommonConst.NUM_ATTENDANCE_2ND_RETURNED;
		return aryStatus;
	}

	/**
	 * {v_EXg
	 * @return	String[][]	o͔͈͔z
	 */
	public static String[][] getManageArray() {
		// ͈̓v_EXg쐬
		String[][] aryScope = new String[3][2];
		aryScope[0][0] = String.valueOf(getManageCode()[0]);
		aryScope[0][1] = CommonConst.NAM_BELONGING_SECTION;
		aryScope[1][0] = String.valueOf(getManageCode()[1]);
		aryScope[1][1] = CommonConst.NAM_SELECT_SECTION;
		aryScope[2][0] = String.valueOf(getManageCode()[2]);
		aryScope[2][1] = CommonConst.NAM_ALL_SECTION;
		return aryScope;
	}

	/**
	 * DTOꐫ`FbN
	 * @param formerDto		ΏDTO
	 * @param currentDto	ΏDTO
	 * @return
	 * <p>
	 * XV̏ꍇtrueAłȂꍇfalse
	 * </p>
	 * @throws MospException 
	 */
	public static boolean chkIdentityDto(BaseDto formerDto, BaseDto currentDto) throws MospException {
		if (chkExistDto(currentDto)) {
			if (formerDto.getUpdateDate().compareTo(currentDto.getUpdateDate()) == 0) {
				return true;
			}
		}
		return false;
	}

	/**
	 * E蓖敪v_EXgiL{^Pj
	 * @return E蓖敪z
	 */
	public static String[][] getPositionAllowanceType1() {
		String[][] array = {
				{ CommonConst.CODE_ALLOWANCE_NONE, 		CommonConst.NAME_ALLOWANCE_NONE		},
				{ CommonConst.CODE_ALLOWANCE_STATE_1, 	CommonConst.NAME_ALLOWANCE_SALARY	}
		};
		return array.clone();
	}

	/**
	 * E蓖敪v_EXgiL{ŒPj
	 * @return E蓖敪z
	 */
	public static String[][] getPositionAllowanceType2() {
		String[][] array = {
				{ CommonConst.CODE_ALLOWANCE_NONE, 		CommonConst.NAME_ALLOWANCE_NONE		},
				{ CommonConst.CODE_ALLOWANCE_STATE_1, 	CommonConst.NAME_ALLOWANCE_FIXED	}
		};
		return array.clone();
	}

	/**
	 * E蓖敪v_EXgiL{^P{ŒPj
	 * @return E蓖敪z
	 */
	public static String[][] getPositionAllowanceType3() {
		String[][] array = {
				{ CommonConst.CODE_ALLOWANCE_NONE, 		CommonConst.NAME_ALLOWANCE_NONE		},
				{ CommonConst.CODE_ALLOWANCE_STATE_1, 	CommonConst.NAME_ALLOWANCE_SALARY	},
				{ CommonConst.CODE_ALLOWANCE_STATE_2, 	CommonConst.NAME_ALLOWANCE_FIXED	}
		};
		return array.clone();
	}

	/**
	 * YtOz
	 * @return YtOz
	 */
	public static String[][] getCorrespondFlagArray() {
		String[][] array = {
				{ CommonConst.NAM_COMMON_FLAG_OFF,	CommonConst.NAM_DEFAULT_FLAG_OFF	},
				{ CommonConst.NAM_COMMON_FLAG_ON,	CommonConst.NAM_DEFAULT_FLAG_ON		}				
		};
		return array.clone();
	}

	/**
	 * tB[h̓̃f[^擾
	 *  0 : t@CID
	 *  1 : Ǘԍ
	 *  2 : tB[hID
	 *  3 : tB[h
	 */
	public static String getEFnameItem(String csvString, int i) {
		//@Ǘԍ擾
		if  (!csvString.equals(""))  {
			String[] arl = csvString.split(CommonConst.STR_CSV_SEPARATOR);
			return arl[i];
		}
		return "";
	}

	/**
	 * ԃtH[}bg
	 * @param hour 
	 * @return ()
	 */
	public static String getHourString(double hour) {
		NumberFormat nf = NumberFormat.getNumberInstance();
		nf.setMaximumFractionDigits(2);
		nf.setMinimumFractionDigits(2);
		return nf.format(hour);
	}

	/**
	 * ԍ擾()
	 * @param date1 It
	 * @param date2 Jnt
	 * @return ԍ(date1 - date2)
	 * @throws Exception
	 */
	public static long getTimeRemainder(Date date1, Date date2) {
		long timeRemainder = date1.getTime() - date2.getTime();
		return (timeRemainder / (1000 * 60));
	}

	/**
	 * Ώ۔NΏ۔Nx擾
	 * @param year		Ώ۔N
	 * @param month		Ώی
	 * @param startmonth	NxJn
	 * @return	Ώ۔Nx
	 * @throws Exception
	 */
	public static int getTargetFiscalYear(int year, int month, int startmonth) {
		// NxJnȌꍇΏ۔N̑ONgpB
		// NxJň̏ꍇ͑Ώ۔Ngp
		int fiscalyear = year;
		if (month < startmonth) {
			fiscalyear--;
		}
		return fiscalyear;
	}

	/**
	 * Ώ۔NxΏ۔N擾
	 * @param fiscalyear		Ώ۔Nx
	 * @param month				Ώی
	 * @param startmonth		NxJn
	 * @return	Ώ۔N
	 */
	public static int getTargetYear(int fiscalyear, int month, int startmonth) {
		// NxJn̑O͑Ώ۔Nx̗N𗘗p
		// NxJň̌͑Ώ۔Nxgp
		int year = fiscalyear;
		if (month < startmonth) {
			year++;
		}
		return year;
	}

}
