/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.dto;

import java.util.Date;

import jp.mosp.common.common.BaseDto;

public class CmIncomeTaxDto extends BaseDto {
	
	private static final long serialVersionUID = 8625578738653861422L;
	
	// tB[h
	private String kCode            ;	// ЈR[h
	private Date   incExpectedDate  ;	// œKpN
	private String incomeTaxType    ;	// ېŋ敪
	private String adjustmentType   ;	// N敪
	private String selfWidowType    ;	// {lǕw敪
	private String selfHandicapType ;	// {lQ敪
	private String selfStudentType  ;	// {lw敪
	private String spouseIntendType ;	// zҋ敪
	private int    generalDependent ;	// ʕ}{e
	private int    specificDependent;	// }{e
	private int    elderlyDependent ;	// Vl}{e
	private int    liveWithEldRel   ;	// Ve
	private int    liveWithHandiGe  ;	// 
	private int    liveWithHandiSp  ;	// 
	private int    liveWithHandiEl  ;	// Vl
	private int    liveWithHandiEr  ;	// Ve
	private int    generalHandicap  ;	// ʏQ
	private int    specificHandicap ;	// ʏQ
	private int    dependentCount   ;	// }{̐
	
	/**
	 * RXgN^
	 */
	public CmIncomeTaxDto(){
		super();
	}
	
	// ANZT\bh
	public String getKCode            () { return kCode                        ; }	// ЈR[h
	public Date   getIncExpectedDate  () { return getDateField(incExpectedDate); }	// œKpN
	public String getIncomeTaxType    () { return incomeTaxType                ; }	// ېŋ敪
	public String getAdjustmentType   () { return adjustmentType               ; }	// N敪
	public String getSelfWidowType    () { return selfWidowType                ; }	// {lǕw敪
	public String getSelfHandicapType () { return selfHandicapType             ; }	// {lQ敪
	public String getSelfStudentType  () { return selfStudentType              ; }	// {lw敪
	public String getSpouseIntendType () { return spouseIntendType             ; }	// zҋ敪
	public int    getGeneralDependent () { return generalDependent             ; }	// ʕ}{e
	public int    getSpecificDependent() { return specificDependent            ; }	// }{e
	public int    getElderlyDependent () { return elderlyDependent             ; }	// Vl}{e
	public int    getLiveWithEldRel   () { return liveWithEldRel               ; }	// Ve
	public int    getLiveWithHandiGe  () { return liveWithHandiGe              ; }	// 
	public int    getLiveWithHandiSp  () { return liveWithHandiSp              ; }	// 
	public int    getLiveWithHandiEl  () { return liveWithHandiEl              ; }	// Vl
	public int    getLiveWithHandiEr  () { return liveWithHandiEr              ; }	// Ve
	public int    getGeneralHandicap  () { return generalHandicap              ; }	// ʏQ
	public int    getSpecificHandicap () { return specificHandicap             ; }	// ʏQ
	public int    getDependentCount   () { return dependentCount               ; }	// }{̐
	
	public void setKCode            (String kCode            ) { this.kCode             = kCode                        ; }	// ЈR[h
	public void setIncExpectedDate  (Date   incExpectedDate  ) { this.incExpectedDate   = getDateField(incExpectedDate); }	// œKpN
	public void setIncomeTaxType    (String incomeTaxType    ) { this.incomeTaxType     = incomeTaxType                ; }	// ېŋ敪
	public void setAdjustmentType   (String adjustmentType   ) { this.adjustmentType    = adjustmentType               ; }	// N敪
	public void setSelfWidowType    (String selfWidowType    ) { this.selfWidowType     = selfWidowType                ; }	// {lǕw敪
	public void setSelfHandicapType (String selfHandicapType ) { this.selfHandicapType  = selfHandicapType             ; }	// {lQ敪
	public void setSelfStudentType  (String selfStudentType  ) { this.selfStudentType   = selfStudentType              ; }	// {lw敪
	public void setSpouseIntendType (String spouseIntendType ) { this.spouseIntendType  = spouseIntendType             ; }	// zҋ敪
	public void setGeneralDependent (int    generalDependent ) { this.generalDependent  = generalDependent             ; }	// ʕ}{e
	public void setSpecificDependent(int    specificDependent) { this.specificDependent = specificDependent            ; }	// }{e
	public void setElderlyDependent (int    elderlyDependent ) { this.elderlyDependent  = elderlyDependent             ; }	// Vl}{e
	public void setLiveWithEldRel   (int    liveWithEldRel   ) { this.liveWithEldRel    = liveWithEldRel               ; }	// Ve
	public void setLiveWithHandiGe  (int    liveWithHandiGe  ) { this.liveWithHandiGe   = liveWithHandiGe              ; }	// 
	public void setLiveWithHandiSp  (int    liveWithHandiSp  ) { this.liveWithHandiSp   = liveWithHandiSp              ; }	// 
	public void setLiveWithHandiEl  (int    liveWithHandiEl  ) { this.liveWithHandiEl   = liveWithHandiEl              ; }	// Vl
	public void setLiveWithHandiEr  (int    liveWithHandiEr  ) { this.liveWithHandiEr   = liveWithHandiEr              ; }	// Ve
	public void setGeneralHandicap  (int    generalHandicap  ) { this.generalHandicap   = generalHandicap              ; }	// ʏQ
	public void setSpecificHandicap (int    specificHandicap ) { this.specificHandicap  = specificHandicap             ; }	// ʏQ
	public void setDependentCount   (int    dependentCount   ) { this.dependentCount    = dependentCount               ; }	// }{̐
	
}

